/*******************************************************************************

NAME            nubdTests.cc
PROGRAMMER      %created_by:    wfagan %

        Copyright 2017 NetApp, Inc. All Rights Reserved.

*******************************************************************************/

#include <iostream>
#include <string.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <eseries/logging.h>
#include <nubd.h>

#include "unittest++/UnitTest++.h"

namespace nubd
{
    static const char* COMPONENT = "eseries-nubd";
}

/**
 * Test entry for eseries-nubd-test test suites
 */
int
main
    (
    int argc,
    char* argv[]
    )
{
    int status = 0;
    bool list_tests = false;

    // parse command line
    for (int i = 0; i < argc; ++i)
    {
        if (strncmp(argv[i], "--list", strlen("--list")) == 0)
            list_tests = true;
    }

    if (list_tests)
    {
        // dump all tests from all suites
        UnitTest::TestList list = UnitTest::Test::GetTestList();
        for (UnitTest::Test* test = list.GetHead(); test; test = test->next)
            std::cout << test->m_details.suiteName << "::" << test->m_details.testName <<std::endl;
    }
    else
    {
        // run all tests from all suites
        status = UnitTest::RunAllTests();
    }

    return status;
}

/**
 * \brief nubd tests.
 */
SUITE(nubd)
{
    /// Test NUBD manager is available.
    TEST(MgrAvailable)
    {
        eseriesLog(nubd::COMPONENT, ESERIES_LOG_DEBUG, "Starting MgrAvailable test.");

        int fd = open(NUBD_MGR_DEV, O_RDONLY);
        CHECK(fd >= 0);
        if (fd < 0)
            return;

        close(fd);
    }
}
